import upygame
import urandom
import sprite

screen = upygame.display.set_mode()

# The ZX Spectrum palette #(2)
upygame.display.set_palette_16bit([
 0, 0x001a, 0xd000, 0x5acb, 0x06a0, 0x06ba, 0x6b4d, 0xd6ba,
 0x0000, 0x001f, 0xf800, 0xf81f, 0x07e0, 0x07ff, 0xffe0, 0xffff
])

destroyer_pixels = b'\
\x00\x00\x00\x00\x03\x00\x00\x00\x00\x00\
\x00\x00\x00\x00\x06\x03\x00\x00\x00\x00\
\x00\x00\x00\x00\x06\x06\x00\x00\x00\x00\
\x00\x00\x00\x00\x66\x66\x60\x00\x00\x00\
\x07\x00\x00\x00\x19\x19\x10\x00\x00\x00\
\x00\x70\x00\x06\x66\x36\x66\x00\x00\x70\
\x00\x06\x60\x00\x6e\x6e\x60\x06\x67\x00\
\x00\x06\x60\x00\x66\xe6\x60\x06\x60\x00\
\x33\x33\x33\x33\x33\x33\x33\x33\x33\x33\
\x00\x33\x33\x33\x33\x33\x33\x33\x33\x30\
\x00\x03\x33\x33\x33\x33\x33\x33\x33\x00\
\x00\x00\x33\x33\x33\x33\x33\x33\x30\x00\
'

deptchargePixels = b'\
\x36\x63\
\x03\x60\
\x06\x30\
\x03\x60\
\x36\x63\
'

submarinePixels = b'\
\x00\x00\x07\x63\x00\x00\x00\x00\x00\
\x00\x00\x06\x63\x00\x00\x00\x00\x00\
\x00\x00\x07\x63\x00\x00\x00\x00\x00\
\x00\x66\x66\x66\x66\x66\x66\x60\x07\
\x06\x63\x66\x36\x63\x66\x36\x66\x06\
\x36\x36\x36\x36\x36\x36\x36\x36\x67\
\x33\x63\x36\x33\x63\x36\x33\x63\x3f\
\x03\x33\x63\x33\x63\x33\x63\x33\x06\
\x00\x33\x33\x33\x33\x33\x33\x30\x07\
'

submarine_rightPixels = b'\
\x00\x00\x00\x00\x00\x36\x70\x00\x00\
\x00\x00\x00\x00\x00\x36\x60\x00\x00\
\x00\x00\x00\x00\x00\x36\x60\x00\x00\
\x70\x06\x63\x33\x66\x63\x66\x66\x00\
\x60\x63\x33\x63\x33\x63\x33\x36\x30\
\x73\x66\x36\x66\x36\x66\x36\x63\x66\
\xf6\x63\x33\x36\x33\x36\x33\x33\x66\
\x60\x63\x36\x33\x36\x63\x33\x63\x38\
\x70\x03\x33\x33\x33\x33\x33\x33\x00\
'

floatbombPixels = b'\
\x0a\xa0\
\x2a\xaa\
\x22\xa2\
\x02\x20\
'


class Submarine(sprite.Sprite):
    def __init__(self, speed):
        sprite.Sprite.__init__(self)
        self.speed_x = 0
        self.x_pos = 0
        self.y_pos = urandom.getrandbits(6) + 15

        self.start_side(speed)
        self.rect = self.submarine.get_rect()
        
    def __del__(self):
        print("Deleted")
        
    def start_side(self, speed):
        if urandom.getrandbits(1) == 0:
            self.x_pos = -10
            self.speed_x = speed
            self.submarine = upygame.surface.Surface(18, 9, submarine_rightPixels);
        else:
            self.x_pos = 110
            self.speed_x = -speed
            self.submarine = upygame.surface.Surface(18, 9, submarinePixels)
        
    def move(self):
        self.x_pos += self.speed_x
        
    def update(self):
        self.move()
        self.rect.x = self.x_pos;
        self.rect.y = self.y_pos;
        screen.blit(self.submarine, self.x_pos, self.y_pos)
        

class Deptcharge(sprite.Sprite):
    def __init__(self, x_pos):
        sprite.Sprite.__init__(self)
        self.x_pos = x_pos
        self.y_pos = 12
        self.deptcharge = upygame.surface.Surface(4, 5, deptchargePixels)
        self.rect = self.deptcharge.get_rect()
        
    def move(self):
        self.y_pos += 1
        
    def update(self):
        self.move()
        self.rect.x = self.x_pos;
        self.rect.y = self.y_pos;
        screen.blit(self.deptcharge, self.x_pos, self.y_pos)
        
class Floatbomb(sprite.Sprite):
    def __init__(self, x_pos, y_pos):
        sprite.Sprite.__init__(self)
        self.x_pos = x_pos
        self.y_pos = y_pos
        self.floatbomb = upygame.surface.Surface(4, 4, floatbombPixels)
        self.rect = self.floatbomb.get_rect()
        
    def move(self):
        self.y_pos -= 1
        
    def update(self):
        self.move()
        self.rect.x = self.x_pos;
        self.rect.y = self.y_pos;
        screen.blit(self.floatbomb, self.x_pos, self.y_pos)

class Destroyer:
    def __init__(self):
        sprite.Sprite.__init__(self)
        self.x_pos = 55
        self.y_pos = 0
        self.speed_x = 0
        self.destroyer = upygame.surface.Surface(20, 12, destroyer_pixels)
        self.rect = self.destroyer.get_rect()

    def update(self):
        if (self.x_pos < 0 and self.speed_x < 0) or (self.x_pos + self.rect.width > 110 and self.speed_x > 0):
            pass
        else:
            self.x_pos += self.speed_x
            self.rect.x = self.x_pos;
            self.rect.y = self.y_pos;
        screen.blit(self.destroyer, self.x_pos, self.y_pos)
        
def intro_screen():
    start = False
    while not start:
        upygame.draw.text(10, 15, "  Welcome to")
        upygame.draw.text(10, 30, "Goose bay 1981")
        upygame.draw.text(10, 60, "Press a key to      play!")
        eventtype = upygame.event.poll()
        if eventtype != upygame.NOEVENT:
            if eventtype.type == upygame.KEYDOWN:
                if (eventtype.key == upygame.BUT_A or
                    eventtype.key == upygame.BUT_B or
                    eventtype.key == upygame.BUT_C): 
                    start = True
        upygame.display.flip()

# levels change with 
# number of simultaneous submarines
# total number of submarines
# speed of submarines
# max number of floatbombs
# speed of floatbombs?

def level_stat(sim_subs, total_subs, speed_subs, max_floatbombs, speed_floatbombs):
    level = {
        'sim_subs': sim_subs,
        'total_subs': total_subs,
        'speed_subs': speed_subs,
        'max_floatbombs': max_floatbombs,
        'speed_floatbombs': speed_floatbombs
    }
    return level


def run_game():

    score = 0
    highscore = 0
    exit = False
    restart = True
    run = True
    show_intro = True
    
    levels = []
    levels.append(level_stat(1, 7, 1, 2, 1))
    levels.append(level_stat(2, 12, 1, 3, 1))
    levels.append(level_stat(3, 25, 1, 5, 1))
    levels.append(level_stat(4, 20, 2, 4, 1))
    levels.append(level_stat(5, 25, 2, 6, 1))
    
    while not exit:
        upygame.draw.rect(upygame.Rect(0,12,120,80), True, 0x0001)
        upygame.draw.rect(upygame.Rect(0,0,120,11), True, 0x0005)

        if show_intro:
            intro_screen()
            show_intro = False
        
        eventtype = upygame.event.poll()
        if eventtype != upygame.NOEVENT:
            if eventtype.type == upygame.KEYDOWN:
                if eventtype.key == upygame.K_RIGHT: 
                    destroyer.speed_x = 2
                if eventtype.key == upygame.K_LEFT:
                    destroyer.speed_x = -2
                if eventtype.key == upygame.BUT_A:
                    if len(deptcharges) < 3:
                        deptcharges.add(Deptcharge(destroyer.x_pos + destroyer.rect.width))
                if eventtype.key == upygame.BUT_B:
                    if len(deptcharges) < 3:
                        deptcharges.add(Deptcharge(destroyer.x_pos))
                if eventtype.key == upygame.BUT_C:
                    restart = True
                    run = True
            if eventtype.type == upygame.KEYUP:
                if eventtype.key == upygame.K_RIGHT or eventtype.key == upygame.K_LEFT:
                    destroyer.speed_x = 0
        
        # Show after game over until key is pressed    
        if not run:
            upygame.draw.text(10, 15, "Last score: {}".format(score))
            upygame.draw.text(10, 30, "High score: {}".format(highscore) )
            upygame.draw.text(10, 60, "Press C to play")
            
        else:
            if restart:
                current_level = 0
                count_subs = 0
                score = 0
                restart = False
                destroyer = Destroyer()
                submarines = sprite.Group()
                deptcharges = sprite.Group()
                floatbombs = sprite.Group()
            
            destroyer.update()
            
            # Deptcharge
            removes = []
            for deptcharge in deptcharges:
                deptcharge.update()
                if deptcharge.y_pos > 90:
                    removes.append(deptcharge)
            for dept in removes:
                deptcharges.remove(dept)
                
            # Submarine
            if len(submarines) < levels[current_level]['sim_subs']:
                submarines.add(Submarine(levels[current_level]['speed_subs']))
                count_subs += 1
            removes = []
            for sub in submarines:
                sub.update()
                if sub.x_pos < -20 or sub.x_pos > 120:
                    removes.append(sub)
                # Does it shoot floatbomb
                if len(floatbombs) < levels[current_level]['max_floatbombs']:
                    if urandom.getrandbits(5) < 1:
                        floatbombs.add(Floatbomb(sub.x_pos, sub.y_pos))
            for sub in removes:
                submarines.remove(sub)
                
            # Floatbomb
            removes = []
            for floatbomb in floatbombs:
                floatbomb.update()
                if floatbomb.y_pos < 11:
                    removes.append(floatbomb)
            for floabomb in removes:
                floatbombs.remove(floabomb)
                    
                
            # Check collision
            removes = []
            for deptcharge in deptcharges:
                hit_sub = sprite.spritecollideany(deptcharge, submarines)
                if hit_sub:
                    score += 1
                    submarines.remove(hit_sub)
                    removes.append(deptcharge)
            for dept in removes:
                deptcharges.remove(dept)
            if sprite.spritecollideany(destroyer, floatbombs):
                if score > highscore:
                    highscore = score
                restart = True
                run = False
                
            upygame.draw.text(90, 80, "{}".format(score))
            upygame.draw.text(5, 80, "{}".format(highscore))
            
            # Check if next level
            if count_subs >= levels[current_level]['total_subs'] and current_level < len(levels) -1:
                count_subs = 0
                current_level += 1
                    
        upygame.display.flip()


if __name__ == '__main__':
    run_game()

    